/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of SpeedyFx.xs. Do not edit this file, edit SpeedyFx.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SpeedyFx.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "nedtrie.h"

#define MAX_MAP_SIZE    0x2ffff
#define SFX_SIGNATURE   0x4c9da21d

#ifndef MAX_TRIE_SIZE
#define MAX_TRIE_SIZE   (1 << 19)
#endif

typedef struct {
    U32 length;
    U32 code_table[];
} SpeedyFx;
typedef SpeedyFx *Text__SpeedyFx;

typedef struct sfxaa_s sfxaa_t;
struct sfxaa_s {
    NEDTRIE_ENTRY(sfxaa_s) link;
    U32 key;
    U32 val;
};
typedef struct sfxaa_tree_s sfxaa_tree_t;
NEDTRIE_HEAD(sfxaa_tree_s, sfxaa_s);

U32 sfxaakeyfunct(const sfxaa_t *r) {
    return r->key;
}

NEDTRIE_GENERATE(static, sfxaa_tree_s, sfxaa_s, link, sfxaakeyfunct, NEDTRIE_NOBBLEONES(sfxaa_tree_s))

typedef struct {
    U32 signature;
    U32 count;
    sfxaa_tree_t root;
    sfxaa_t *last;
    sfxaa_t index[MAX_TRIE_SIZE];
} SpeedyFxResult;
typedef SpeedyFxResult *Text__SpeedyFx__Result;

SV *result_init () {
    SV *res;
    int count;

    dSP;
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSVpv("Text::SpeedyFx::Result", 0)));
    PUTBACK;

    count = call_method("new", G_SCALAR);
    SPAGAIN;

    if (count != 1)
        croak("couldn't construct new Text::SpeedyFx::Result object");

    res = newSVsv(POPs);

    PUTBACK;
    FREETMPS;
    LEAVE;

    return res;
}

SpeedyFxResult *result_addr (SV *self) {
    SV *hash;
    MAGIC *magic;
    SV *attr;
    SpeedyFxResult *pSpeedyFxResult = NULL;

    hash = SvRV(self);
    if (SvRMAGICAL((SV *) hash)) {
        if ((magic = mg_find((SV *) hash, PERL_MAGIC_tied)) != NULL) {
            attr = magic->mg_obj;
            if (SvROK(attr)) {
                pSpeedyFxResult = (SpeedyFxResult *) SvIV(SvRV(attr));
                if (pSpeedyFxResult->signature != SFX_SIGNATURE) {
                    pSpeedyFxResult = NULL;
                }
            }
        }
    }

    return pSpeedyFxResult;
}

#if PERL_VERSION >= 16
#define ChrCode(u, v, len) (U32) utf8_to_uvchr_buf(u, v, len)
#else
#define ChrCode(u, v, len) (U32) utf8_to_uvchr(u, len)
#endif

#if PERL_VERSION >= 26
#define ChrIsAlphanum(s, end) isWORDCHAR_utf8_safe(s, end)
#define ChrToLower(p, e, s, lenp) toLOWER_utf8_safe(p, e, s, lenp)
#else
#define ChrIsAlphanum(s, end) isALNUM_utf8(s)
#define ChrToLower(p, e, s, lenp) toLOWER_utf8(p, s, lenp)
#endif

#define SetBit(a, b)    (((U8 *) a)[(b) >> 3] |= (1 << ((b) & 7)))
#define FastMin(x, y)   (y ^ ((x ^ y) & -(x < y)))

#define _SPEEDYFX_INIT                                                          \
    U32 code, c;                                                                \
    U32 wordhash = 0;                                                           \
    STRLEN len;                                                                 \
    U32 length = pSpeedyFx->length;                                             \
    U32 *code_table = pSpeedyFx->code_table;                                    \
    U8 *s, *se;                                                                 \
    s = (U8 *) SvPV(str, len);                                                  \
    se = s + len;

#define _WALK_LATIN1    c = *s++
#define _WALK_UTF8      c = ChrCode(s, se, &len); s += len

#define _SPEEDYFX(_STORE, _WALK, _LENGTH)                                       \
    STMT_START {                                                                \
        while (*s) {                                                            \
            _WALK;                                                              \
            if ((code = code_table[c % _LENGTH]) != 0)                          \
                wordhash = (wordhash >> 1) + code;                              \
            else if (wordhash) {                                                \
                _STORE;                                                         \
                wordhash = 0;                                                   \
            }                                                                   \
        }                                                                       \
        if (wordhash) {                                                         \
            _STORE;                                                             \
        }                                                                       \
    } STMT_END

#define _NEDTRIE_STORE                                                          \
    tmp.key = wordhash;                                                         \
    if ((p = NEDTRIE_FIND(sfxaa_tree_s, root, &tmp)) != 0)                      \
        p->val++;                                                               \
    else {                                                                      \
        if ((p = slot++) == end)                                                \
            croak("too many unique tokens in a single data chunk");             \
        p->key = wordhash;                                                      \
        p->val = 1;                                                             \
        NEDTRIE_INSERT(sfxaa_tree_s, root, p);                                  \
    }

#line 163 "SpeedyFx.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 307 "SpeedyFx.c"

XS_EUPXS(XS_Text__SpeedyFx__Result_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "package, ...");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
#line 161 "SpeedyFx.xs"
    SpeedyFxResult *pSpeedyFxResult;
    HV *thingy;
    HV *stash;
    SV *tie;
#line 323 "SpeedyFx.c"
	SV *	RETVAL;
#line 166 "SpeedyFx.xs"
    Newx(pSpeedyFxResult, 1, SpeedyFxResult);
    pSpeedyFxResult->signature = SFX_SIGNATURE;
    pSpeedyFxResult->count = 0;

    NEDTRIE_INIT(&(pSpeedyFxResult->root));

    thingy = newHV();
    tie = newRV_noinc(newSViv(PTR2IV(pSpeedyFxResult)));
    stash = gv_stashpv(package, GV_ADD);
    sv_bless(tie, stash);
    hv_magic(thingy, (GV *) tie, PERL_MAGIC_tied);
    sv_free(tie);

    RETVAL = newRV_noinc((SV *) thingy);
#line 340 "SpeedyFx.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__SpeedyFx__Result_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pSpeedyFxResult, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;
	SV *	key = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::FETCH",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 188 "SpeedyFx.xs"
    sfxaa_t *p, tmp;
#line 376 "SpeedyFx.c"
#line 190 "SpeedyFx.xs"
    tmp.key = SvNV(key);
    if ((p = NEDTRIE_FIND(sfxaa_tree_s, &(pSpeedyFxResult->root), &tmp)) == 0) {
        XSRETURN_UNDEF;
    } else {
        ST(0) = sv_2mortal(newSVnv(p->val));
        XSRETURN(1);
    }
#line 385 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pSpeedyFxResult, key, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;
	SV *	key = ST(1)
;
	SV *	value = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::STORE",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 204 "SpeedyFx.xs"
    sfxaa_t *p, tmp;
#line 422 "SpeedyFx.c"
#line 206 "SpeedyFx.xs"
    tmp.key = SvNV(key);
    tmp.val = SvNV(value);
    if ((p = NEDTRIE_FIND(sfxaa_tree_s, &(pSpeedyFxResult->root), &tmp)) != 0)
        p->val = tmp.val;
    else {
        if (pSpeedyFxResult->count++ >= MAX_TRIE_SIZE)
            croak("too many unique tokens in a single data chunk");
        p = &(pSpeedyFxResult->index[pSpeedyFxResult->count]);
        p->key = tmp.key;
        p->val = tmp.val;
        NEDTRIE_INSERT(sfxaa_tree_s, &(pSpeedyFxResult->root), p);
    }
#line 436 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pSpeedyFxResult, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;
	SV *	key = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::DELETE",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 224 "SpeedyFx.xs"
    sfxaa_t *p, tmp;
#line 471 "SpeedyFx.c"
#line 226 "SpeedyFx.xs"
    tmp.key = SvNV(key);
    if ((p = NEDTRIE_FIND(sfxaa_tree_s, &(pSpeedyFxResult->root), &tmp)) == 0) {
        XSRETURN_UNDEF;
    } else {
        ST(0) = sv_2mortal(newSVnv(p->val));
        NEDTRIE_REMOVE(sfxaa_tree_s, &(pSpeedyFxResult->root), p);
        XSRETURN(1);
    }
#line 481 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pSpeedyFxResult");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::CLEAR",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 239 "SpeedyFx.xs"
    NEDTRIE_INIT(&(pSpeedyFxResult->root));
    pSpeedyFxResult->count = 0;
#line 515 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pSpeedyFxResult, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;
	SV *	key = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::EXISTS",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 247 "SpeedyFx.xs"
    sfxaa_t *p, tmp;
#line 550 "SpeedyFx.c"
#line 249 "SpeedyFx.xs"
    tmp.key = SvNV(key);
    if ((p = NEDTRIE_FIND(sfxaa_tree_s, &(pSpeedyFxResult->root), &tmp)) == 0) {
        XSRETURN_NO;
    } else {
        XSRETURN_YES;
    }
#line 558 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pSpeedyFxResult");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::FIRSTKEY",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 260 "SpeedyFx.xs"
    sfxaa_t *p;
#line 591 "SpeedyFx.c"
#line 262 "SpeedyFx.xs"
    if ((p = NEDTRIE_MIN(sfxaa_tree_s, &(pSpeedyFxResult->root))) == 0) {
        XSRETURN_UNDEF;
    } else {
        pSpeedyFxResult->last = p;

        ST(0) = sv_2mortal(newSVnv(p->key));
        XSRETURN(1);
    }
#line 601 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "pSpeedyFxResult, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::NEXTKEY",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 275 "SpeedyFx.xs"
    sfxaa_t *p;
#line 634 "SpeedyFx.c"
#line 277 "SpeedyFx.xs"
    if ((p = NEDTRIE_NEXT(sfxaa_tree_s, &(pSpeedyFxResult->root), pSpeedyFxResult->last)) == 0) {
        XSRETURN_UNDEF;
    } else {
        pSpeedyFxResult->last = p;

        ST(0) = sv_2mortal(newSVnv(p->key));
        XSRETURN(1);
    }
#line 644 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pSpeedyFxResult");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx::Result")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::Result::SCALAR",
			"pSpeedyFxResult", "Text::SpeedyFx::Result",
			refstr, ST(0)
		);
	}
;
#line 290 "SpeedyFx.xs"
    ST(0) = sv_2mortal(newSVpvf("%d/%d", pSpeedyFxResult->count, MAX_TRIE_SIZE));
    XSRETURN(1);
#line 678 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_UNTIE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_UNTIE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 296 "SpeedyFx.xs"
    croak("not implemented");
#line 696 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx__Result_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx__Result_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pSpeedyFxResult");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx__Result	pSpeedyFxResult;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFxResult = INT2PTR(Text__SpeedyFx__Result,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Text::SpeedyFx::Result::DESTROY",
			"pSpeedyFxResult")
;
#line 302 "SpeedyFx.xs"
    Safefree(pSpeedyFxResult);
#line 725 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx_new)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 311 "SpeedyFx.xs"
    U32 seed = 1;
    U8 bits = 18;
    static U32 fold_init = 0;
    static U32 fold_table[MAX_MAP_SIZE];
#line 744 "SpeedyFx.c"
	Text__SpeedyFx	RETVAL;
#line 316 "SpeedyFx.xs"
    U32 i;
    U8 s[8];
    U8 *t;
    U8 u[8], *v;
    UV c;
    STRLEN len;
    U32 length, *code_table;
    U32 rand_table[MAX_MAP_SIZE];
#line 755 "SpeedyFx.c"
#line 325 "SpeedyFx.xs"
    if (items > 1)
        seed = SvNV(ST(1));
    if (items > 2)
        bits = SvNV(ST(2));

    if (seed == 0)
        croak("seed must be not 0!");

    if (bits <= 8)
        length = 256;
    else if (bits > 17)
        length = MAX_MAP_SIZE;
    else
        length = 1 << bits;

    SpeedyFx *pSpeedyFx;
    Newxc(pSpeedyFx, 1 + length, U32, SpeedyFx);

    pSpeedyFx->length = length;
    code_table = pSpeedyFx->code_table;

    fold_table[0] = 0;
    if (fold_init < length) {
        for (i = fold_init + 1; i < length; i++) {
            if (i >= 0xd800 && i <= 0xdfff)         // high/low-surrogate code points
                c = 0;
            else if (i >= 0xfdd0 && i <= 0xfdef)    // noncharacters
                c = 0;
            else if ((i & 0xffff) == 0xfffe)        // noncharacters
                c = 0;
            else if ((i & 0xffff) == 0xffff)        // noncharacters
                c = 0;
            else {
                t = uvchr_to_utf8(s, (UV) i);
                *t = '\0';

                if (ChrIsAlphanum(s, t)) {
                    (void) ChrToLower(s, t, u, &len);
                    *(u + len) = '\0';
                    v = u + len;

                    c = ChrCode(u, v, &len);

                    // grow the tables, if necessary
                    if (length < c)
                        length = c;
                } else
                    c = 0;
            }
            fold_table[i] = c;
        }
        fold_init = length;
    }

    if (pSpeedyFx->length != length) {
        Renewc(pSpeedyFx, 1 + length, U32, SpeedyFx);

        pSpeedyFx->length = length;
        code_table = pSpeedyFx->code_table;
    }
    Zero(code_table, length, U32);

    rand_table[0] = seed;
    for (i = 1; i < length; i++)
        rand_table[i]
            = (
                rand_table[i - 1]
                * 0x10a860c1
            ) % 0xfffffffb;

    for (i = 0; i < length; i++)
        if (fold_table[i])
            code_table[i] = rand_table[fold_table[i]];

    RETVAL = pSpeedyFx;
#line 832 "SpeedyFx.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Text::SpeedyFx", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__SpeedyFx_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pSpeedyFx, str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx	pSpeedyFx;
	SV *	str = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFx = INT2PTR(Text__SpeedyFx,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::hash",
			"pSpeedyFx", "Text::SpeedyFx",
			refstr, ST(0)
		);
	}
;
#line 408 "SpeedyFx.xs"
    _SPEEDYFX_INIT;
    SV *res;
    SpeedyFxResult *pSpeedyFxResult;
    sfxaa_tree_t *root;
    sfxaa_t *p, *slot, *end, tmp;
#line 876 "SpeedyFx.c"
#line 414 "SpeedyFx.xs"
    res = result_init();
    if ((pSpeedyFxResult = result_addr(res)) == NULL)
        croak("TARFU");

    root    = &(pSpeedyFxResult->root);
    slot    = &(pSpeedyFxResult->index[0]);
    end     = &(pSpeedyFxResult->index[MAX_TRIE_SIZE]);

    if (length > 256) {
        _SPEEDYFX(_NEDTRIE_STORE, _WALK_UTF8, length);
    } else {
        _SPEEDYFX(_NEDTRIE_STORE, _WALK_LATIN1, 256);
    }

    pSpeedyFxResult->count = (slot - pSpeedyFxResult->index) / sizeof(sfxaa_t);

    ST(0) = sv_2mortal(res);
    XSRETURN(1);
#line 896 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pSpeedyFx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx	pSpeedyFx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFx = INT2PTR(Text__SpeedyFx,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Text::SpeedyFx::DESTROY",
			"pSpeedyFx")
;
#line 437 "SpeedyFx.xs"
    Safefree(pSpeedyFx);
    XSRETURN(0);
#line 926 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx_hash_fv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx_hash_fv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pSpeedyFx, str, n");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx	pSpeedyFx;
	SV *	str = ST(1)
;
	U32	n = (unsigned long)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFx = INT2PTR(Text__SpeedyFx,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::hash_fv",
			"pSpeedyFx", "Text::SpeedyFx",
			refstr, ST(0)
		);
	}
;
#line 446 "SpeedyFx.xs"
    _SPEEDYFX_INIT;
    U32 size = ceil((float) n / 8.0);
    char *fv;
#line 965 "SpeedyFx.c"
#line 450 "SpeedyFx.xs"
    Newxz(fv, size, char);

    if (length > 256) {
        _SPEEDYFX(SetBit(fv, wordhash % n), _WALK_UTF8, length);
    } else {
        _SPEEDYFX(SetBit(fv, wordhash % n), _WALK_LATIN1, 256);
    }

    ST(0) = sv_2mortal(newSVpv(fv, size));
    Safefree(fv);
    XSRETURN(1);
#line 978 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__SpeedyFx_hash_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__SpeedyFx_hash_min)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pSpeedyFx, str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__SpeedyFx	pSpeedyFx;
	SV *	str = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::SpeedyFx")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pSpeedyFx = INT2PTR(Text__SpeedyFx,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::SpeedyFx::hash_min",
			"pSpeedyFx", "Text::SpeedyFx",
			refstr, ST(0)
		);
	}
;
#line 467 "SpeedyFx.xs"
    _SPEEDYFX_INIT;
    U32 min = 0xffffffff;
#line 1014 "SpeedyFx.c"
#line 470 "SpeedyFx.xs"
    if (length > 256) {
        _SPEEDYFX(min = FastMin(min, wordhash), _WALK_UTF8, length);
    } else {
        _SPEEDYFX(min = FastMin(min, wordhash), _WALK_LATIN1, 256);
    }

    ST(0) = sv_2mortal(newSVnv(min));
    XSRETURN(1);
#line 1024 "SpeedyFx.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Text__SpeedyFx); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__SpeedyFx)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Text::SpeedyFx::Result::new", XS_Text__SpeedyFx__Result_new, file, "$;@");
        (void)newXSproto_portable("Text::SpeedyFx::Result::FETCH", XS_Text__SpeedyFx__Result_FETCH, file, "$$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::STORE", XS_Text__SpeedyFx__Result_STORE, file, "$$$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::DELETE", XS_Text__SpeedyFx__Result_DELETE, file, "$$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::CLEAR", XS_Text__SpeedyFx__Result_CLEAR, file, "$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::EXISTS", XS_Text__SpeedyFx__Result_EXISTS, file, "$$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::FIRSTKEY", XS_Text__SpeedyFx__Result_FIRSTKEY, file, "$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::NEXTKEY", XS_Text__SpeedyFx__Result_NEXTKEY, file, "$;@");
        (void)newXSproto_portable("Text::SpeedyFx::Result::SCALAR", XS_Text__SpeedyFx__Result_SCALAR, file, "$");
        (void)newXSproto_portable("Text::SpeedyFx::Result::UNTIE", XS_Text__SpeedyFx__Result_UNTIE, file, ";@");
        (void)newXSproto_portable("Text::SpeedyFx::Result::DESTROY", XS_Text__SpeedyFx__Result_DESTROY, file, "$");
        (void)newXSproto_portable("Text::SpeedyFx::new", XS_Text__SpeedyFx_new, file, ";@");
        (void)newXSproto_portable("Text::SpeedyFx::hash", XS_Text__SpeedyFx_hash, file, "$$");
        (void)newXSproto_portable("Text::SpeedyFx::DESTROY", XS_Text__SpeedyFx_DESTROY, file, "$");
        (void)newXSproto_portable("Text::SpeedyFx::hash_fv", XS_Text__SpeedyFx_hash_fv, file, "$$$");
        (void)newXSproto_portable("Text::SpeedyFx::hash_min", XS_Text__SpeedyFx_hash_min, file, "$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
